Host API does not return all parameters (e.g. from locations, et al.)
Description

The data passed to the host/managed/after_build hook does not contain any parameter data. For example:

# cat HOOKIN | json_reformat

{

  "host": {

[..]

    "all_puppetclasses": [

    ],

    "parameters": [

    ],

    "interfaces": [

    ],

    "puppetclasses": [

    ],

    "config_groups": [

    ]

  }

}

 Version-Release number of selected component (if applicable):

6.1 GA

How reproducible:

Always.

Steps to Reproduce:

1. In the location, add some paramter data (we add for example time-zone (and set this to 'America/New_York')

2) Add a hook to host/managed/after_build (we simply cat stdin to a tmp file for analysis)

3) the JSON does NOT contain ANY parameter data

Actual results:

the JSON does NOT contain ANY parameter data

Expected results:

The parameter data to be populated correctly with ALL parameters which would be applicable to that host.

Additional info:

Related issues:
Related to Foreman - Feature #3220: API for "rendered" view of host parameter... New 10/08/2013

Related to Foreman - Bug #11860: N+1 query on API hosts#show from inherited p... New 09/17/2015

Related to Foreman - Bug #12132: API host's all parameters should also displa... Closed 10/11/2015

Related to Foreman - Refactor #12179: String extraction in host_inherited_par... Closed 10/15/2015

Has duplicate Foreman - Bug #12981: Host API does not return all parameters f... Resolved 01/04/2016

Associated revisions

Revision a4d21e68 - 09/17/2015 04:00 AM - Shlomi Zadok

Fixes #11763 - Add inherited parameters to Host view api

History

#1 - 09/10/2015 09:18 AM - Stephen Benjamin

- Related to Feature #3220: API for "rendered" view of host parameters, taking into account inheritance added

#2 - 09/10/2015 09:18 AM - Stephen Benjamin

Hooks uses the API "show" JSON.

That `parameters` key only contains those directly associated to the host, not the inherited ones. The reason being is when working with the API, you

can only edit the parameters directly attached to the host, so that's all you're generally interested in.

The API needs to provide an `all_parameters` key like we do for puppetclasses, which provides the full set of resolved parameters from Locations,

Hostgroups, etc.

#3 - 09/12/2015 09:29 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/2707 added

- Pull request deleted ()

#4 - 09/17/2015 04:03 AM - Shlomi Zadok

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset a4d21e680b3178f5170fe7d7b03276f4042e7839.

#5 - 09/17/2015 04:06 AM - Dominic Cleal

- Assignee set to Shlomi Zadok

- % Done changed from 100 to 0

- translation missing: en.field_release set to 63

#6 - 09/17/2015 04:09 AM - Dominic Cleal

- Related to Bug #11860: N+1 query on API hosts#show from inherited parameters added

#7 - 09/17/2015 04:10 AM - Dominic Cleal

- % Done changed from 0 to 100

#8 - 10/12/2015 02:12 AM - Dominic Cleal

- Related to Bug #12132: API host's all parameters should also display host's parameters  added

#9 - 10/20/2015 06:42 AM - Dominic Cleal

- Related to Refactor #12179: String extraction in host_inherited_params is wrong added

#10 - 01/04/2016 10:49 AM - Dominic Cleal

- Has duplicate Bug #12981: Host API does not return all parameters for locations added
